using System;
using System.Drawing;
using System.Windows.Forms;
using Syncfusion.Drawing;
using Syncfusion.Windows.Forms.Chart;

namespace CustomZooming
{
    public partial class Form1 : Form
    {
      private bool isDraw;
      //Rectangle rect;
      public Form1()
        {
            InitializeComponent();
            this.chartControl1.Text = "Essential Chart";
        }

      private Point downPoint = new Point();
      private Point upPoint = new Point();
      private Point mpoint = new Point();

        private void chartControl1_ChartRegionMouseDown(object sender, ChartRegionMouseEventArgs e)
        {
          this.downPoint = returnPoint();
            isDraw = true;
        }

        private void chartControl1_ChartRegionMouseMove(object sender, ChartRegionMouseEventArgs e)
        {
            mpoint = e.Point;

            this.upPoint = returnPoint();
          
            //if (MouseButtons != MouseButtons.Left && !isDraw)
            //{
            //    return;
            //}

            //ChartControl chart = sender as ChartControl;
            //if (chart == null)
            //{
            //    return;
            //}

            //if (this.downPoint != Point.Empty && e.Point != Point.Empty)
            //{
            //    rect = new Rectangle();

            //    rect.X = Math.Min(this.downPoint.X, e.Point.X);
            //    rect.Width = Math.Abs(e.Point.X - this.downPoint.X);
            //    rect.Y = chart.ChartArea.RenderBounds.Y;
            //    rect.Height = chart.ChartArea.RenderBounds.Height;

            //    BrushInfo br = new BrushInfo(125, new BrushInfo(SystemColors.Highlight));
            //    BrushPaint.FillRectangle(chart.GetGraphics(), rect, br);

            //}
        }

      private Point returnPoint()
      {
        return mpoint;
      }

      private void chartControl1_ChartRegionMouseUp(object sender, ChartRegionMouseEventArgs e)
      {
        isDraw = false;
      }

      private void chartControl1_ChartAreaPaint(object sender, PaintEventArgs e)
      {
        if (isDraw)
        {
          int x = this.downPoint.X;
          int y = this.chartControl1.ChartArea.RenderBounds.Top;
          int width = this.upPoint.X - this.downPoint.X;
          int height = (int)this.chartControl1.PrimaryYAxis.Size.Height;

          // To draw a rectangle outline
          //e.Graphics.DrawRectangle(Pens.Gray, new Rectangle(x, y, width, height));

          // To draw a rectangle and fill it with the selected color
          e.Graphics.FillRectangle(Brushes.Gray, new Rectangle(x, y, width, height));
        }
      }
    }
}